(*
  Copyright (c) 2023 PA-Soft e.U. (https://www.pa-soft.com)

  This code is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This code is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  When using or distributing this code, you must preserve this original
  copyright notice.

  You should have received a copy of the GNU General Public License
  along with this code. If not, see <https://www.gnu.org/licenses/>.
*)

unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, Winapi.ShellAPI,
  System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  Vcl.ExtCtrls, Vcl.Buttons, System.ImageList, Vcl.ImgList, Vcl.ComCtrls;

type
  TForm1 = class(TForm)
    Paneltest1: TPanel;
    LabelContent: TLabel;
    SpeedButtonMinimized: TSpeedButton;
    CheckBoxPanelMinimized: TCheckBox;
    Splitter1: TSplitter;
    ImageList1: TImageList;
    ButtonPASoft: TButton;
    StatusBar1: TStatusBar;
    procedure ButtonPASoftClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBoxPanelMinimizedClick(Sender: TObject);
    procedure SpeedButtonMinimizedClick(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
  private
    const
      FShrinkedWidth = 32;
    procedure TogglePanelMinimized(AValue: Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ButtonPASoftClick(Sender: TObject);
begin
  Winapi.ShellAPI.ShellExecute(Handle, 'open', PChar('https://www.pa-soft.com'), nil, nil, SW_SHOWNORMAL);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  TogglePanelMinimized(False);
end;

procedure TForm1.CheckBoxPanelMinimizedClick(Sender: TObject);
begin
  TogglePanelMinimized(CheckBoxPanelMinimized.Checked);
end;

procedure TForm1.TogglePanelMinimized(AValue: Boolean);
begin
  if AValue = True then // if the Panel is currently expanded
  begin
    // Minimize the Panel:
    Paneltest1.Width := FShrinkedWidth;
    SpeedButtonMinimized.ImageIndex := 1;
    SpeedButtonMinimized.Hint := 'Click here to EXPAND this Panel';
    Paneltest1.BevelEdges := [beLeft];
  end
  else // if the Panel is currently minimized
  begin
    // Expand the Panel:
    Paneltest1.Width := Paneltest1.Tag;
    SpeedButtonMinimized.ImageIndex := 0;
    SpeedButtonMinimized.Hint := 'Click here to SHRINK this Panel';
    Paneltest1.BevelEdges := [beTop,beRight,beBottom];
  end;

  LabelContent.Visible := not AValue; // make the content visible or invisible
  Splitter1.Visible := not AValue;
  CheckBoxPanelMinimized.Checked := Avalue;
end;

procedure TForm1.SpeedButtonMinimizedClick(Sender: TObject);
begin
  TogglePanelMinimized(SpeedButtonMinimized.ImageIndex = 0);
end;

procedure TForm1.Splitter1Moved(Sender: TObject);
begin
  Paneltest1.Tag := Paneltest1.Width;
end;

end.
